#ifdef COHERENT
#include <ctype.h>
#include <sys/stat.h>
#endif

#include "bbt.h"

/*-----------------------------------------------------------------*/
/*---------------------------S E N D-------------------------------*/
/*-----------------------------------------------------------------*/

extern long atol();

send_file()
{
    FILE *fp;
    int i,bad_crc,retry,org_packet_size,wsync;
	unsigned hcrc;
#ifdef QNX
    struct dir_entry dir_entry;
#endif
    long lp;

    org_packet_size = packet_size;

#if 0
    check_compress( file_name );
#endif
    fp = fopen( file_name, "r" );   /* Ouverture du fichier a envoyer */
    if ( !fp )
        {
        set_option (options);
        printf("\nUnable to open file (%s).\n", file_name );
        exit(0);
        }
    fseek( fp, 0L, 2 );             /* On va en fin de fichier */
    file_size = ftell( fp );        /* Position en octet dans le fichier */
    fseek( fp, 0L, 0 );             /* On retourne au debut ! */

    if ( verbose ) printf("%s (Size %ld) ", file_name, file_size );

    if ( !upload )
        {
        if ( !look )
            {
            sprintf( trash, "%c%c%c%c",   0x1b, 0x3a, 0x64, 0x53 );
            write_mdm( trash );
            sprintf( trash, "%c%c%c%c",   0x1b, 0x3a, 0x64, 0x52 );
            write_mdm( trash );
            mec_off();
            }
        }
    else
        {
        ret_deb();
        sleep(5);
        /* Clear Input QNX Buffer... */
        fflush( lect );
        fflush( ecri );
#ifdef QNX
        flush_input( lect );
#endif
        }
    file_perm = filemode( file_name );      /* Les perm du fichier */

#ifdef QNX
    if ( get_dir_entry( fp, &dir_entry ) == 0 )
        file_date = dir_entry.fseconds + 0x12ceec50;
    else
        file_date = time(NULL ) + 0x12ceec50;
#else
#ifndef COHERENT
    time( &file_date );
#else
    {
    struct stat strstat;

    fstat (fileno (fp), &strstat);
    file_date = strstat.st_mtime;
    }
#endif
#endif

    /* Clear Input QNX Buffer... */
    fflush( lect );
    fflush( ecri );

    retry = 0;


	/* FIXE bug dans cencode() et cdecode(), gros debordement */
	compress = 0;

    do  {
        sprintf( trash, "\r\r%s\r",  SS_TRANS );
        write_mdm( trash );

        version = VERSION;
        if ( fversion != -1 ) version = fversion;


		memset( &rb[0], 0, 128 );
		sprintf( rb, "%08ld %s %08lx %03d %02x %d %d",
				file_size, file_name, file_date,
				file_perm, version, compress, bits8 );

		hcrc = calcrc( strlen(rb), rb );

		sprintf( trash, "%s %04x\r", rb, hcrc );
		write_mdm( trash );

		memset( &rb[0], 0, 128 );

        get_paquet(10);
        }
    while ( retry++ < 4 && !rb[0] );

	/* skip all (videotex cmd code) untill '!' */
	while ( strlen(rb) > 1 && rb[0] != '!' ) strcpy( rb, rb+1 );

    if( rb[0] != '!' )
        {
        set_option( lect, options );

        if ( !upload && !look ) mec_on(); else ret_fin();
        printf("Unable to locate Remote BBT.\n");
        exit (1);
        }
	else
		{
		int rver,pck;
		long pos;
		unsigned ccrc = 0, acrc = 0;

		sscanf( rb+1, "%d %ld %d %x", &rver, &pos, &pck, &acrc );

		if ( rver != 0 ) version = rver;
		if ( version > 5 )
			{
			rb[ strlen(rb)-4 ] = '\0';
			ccrc = checksum( rb, strlen(rb) );
			if ( acrc != ccrc )
				{
		        write_mdm( "#BREAK#\r" );
	            set_option( lect, options );
				fclose( fp );
				fp = NULL;
				exit(-1);
				}
			}
	    if ( version < 3 ) compress = 0;
		if ( version < 5 ) bits8 = 0;
		if ( pck != 0 && packet_size > pck ) packet_size = org_packet_size = pck;
		if ( pos != 0L )
			{
    	    if ( fseek( fp, pos, 0 ) != 0 )
    	        {
    	        set_option( lect, options );
    	        if ( !upload && !look ) mec_on(); else ret_fin();
    	        abort("Unable to update remote file.\n");
    	        }
			}
		}


    if ( verbose )
        {
        printf("(%-4.4s)%c ",
                version==0 ? "Sum"  :
                version==1 ? "Crc"  :
                version==2 ? "Crc+" :
				version==3 ? "CrcC" :
				version==4 ? "CrcS" :
				version==5 ? "8Crc" :
				version==6 ? "8Sec" : "????",
                compress   ?  'C'   : ' ' );
        }

    bad_crc = 0;
    nump = 1;

    while ( ! feof( fp ) )
    {

    zero( &rb[0], 8192 );       /* Lecture du fichier */
    lp = ftell( fp );           /* Last position en lecture */

#if 1
    for(i=0; i<packet_size && !feof(fp); i++)
        {
        rb[i] = getc( fp );

        /* Si c'est un fichier TEXTE Transforme le CR(QNX) en CR(UNIX/AMIGA) */
        if ( text && rb[i] == 0x1e ) rb[i]=0x0a;
        }
#else
	i = fread( &rb[0], sizeof(char), packet_size, fp );
#endif

#ifdef COHERENT
    if (feof (fp)) {
        i--;
        rb[i] = 0;
    }
#endif
    if ( verbose ) printf("%9ld", ftell(fp) );

    encode( i );                /* Encode ce qui vient d'etre lu */

    /* Ici DEcode = ENcode... economie de var */

    dev_write_mdm( de );
    write_mdm( "\r" );

	do	{

		wsync = 0;

	    get_paquet(0);              /* Attend acquittement */


		/* Acquittement. TOUT VA BIEN */
	    if ( rb[0] == '!' )
	        {
	        bad_crc = 0;
	        if ( packet_size < org_packet_size ) packet_size *= 2;
	        if ( packet_size > org_packet_size ) packet_size = org_packet_size;
	        }
	    else
		/* Acquittement. Mauvais CRC  ou  parasite et version < 4 */ 
	    if ( rb[0] == '?' || version < 4 )
	        {
	        bad_crc++;
	        if ( verbose ) printf("Crc");
	        if ( slide && packet_size > 256 ) packet_size /= 2;
	        fseek( fp, (long) lp, 0 );
#ifdef UNIX
	        clearerr (fp);
#endif
	        }
	    else
		/* Acquittement. PARASITE sur la ligne on se re-synchronise */
	        {
	        if ( verbose ) printf("SYN");

			/* En cas de mauvais CRC sur une synchro ne pas
			 * pas aquiter par "?H\r" mais par "/H\r" */
			if ( version > 5 )
				{
				unsigned scrc;

		        sprintf( de, "+%ld ", lp );
				scrc = checksum( de, strlen(de) );
				sprintf( de, "+%ld %04x\r", lp, scrc );
				}
			else
		        sprintf( de, "+%ld\r", lp );
	        write_mdm( de );

			fseek( fp, (long) lp, 0 );

            wsync = 1;
	        }
		}
	while ( wsync );


    }

    fclose( fp );



    sprintf( trash, "%s\r",  SS_TRANS );
    write_mdm( trash );

    get_paquet(0);              /* Attend aquitement */

    if ( !upload )
        {
        if ( !look )    mec_on();
        }
    else
        {
        ret_fin();
        }

    if ( verbose )
    {
    if ( rb[0] == '#' ) printf("File Sent !\n");
    else                printf("File Sent Ack !\n");
    }

#ifdef QBBS
    /* -------------------- SPECIAL QBBS -------------------- */
    qbbs_download( cuserid(NULL), file_name, file_size,
                version==0 ? "BBT Sum"  :
                version==1 ? "BBT Crc"  :
                version==2 ? "BBT Crc+" :
				version==3 ? "BBT CrcC" :
				version==4 ? "BBT CrcS" :
				version==5 ? "BBT 8Crc" :
				version==6 ? "BBT 8Sec" : "????"
                );
    /* ------------------------------------------------------ */
#endif
}

#if 0
check_compress( filename )
char *filename;
{
    compress=1;
    if ( strlen( filename ) < 4 ) return;

    if ( strncmpi( filename+strlen(filename)-4, ".arc", 4 ) == 0 ) compress = 0;
    if ( strncmpi( filename+strlen(filename)-4, ".zip", 4 ) == 0 ) compress = 0;
    if ( strncmpi( filename+strlen(filename)-4, ".zoo", 4 ) == 0 ) compress = 0;
    if ( strncmpi( filename+strlen(filename)-4, ".lzh", 4 ) == 0 ) compress = 0;
    if ( strncmpi( filename+strlen(filename)-4, ".pak", 4 ) == 0 ) compress = 0;
    if ( strncmpi( filename+strlen(filename)-4, ".sit", 4 ) == 0 ) compress = 0;
    if ( strncmpi( filename+strlen(filename)-4, ".hxq", 4 ) == 0 ) compress = 0;
    if ( strncmpi( filename+strlen(filename)-4, ".cpt", 4 ) == 0 ) compress = 0;
    if ( strncmpi( filename+strlen(filename)-2, ".z",   2 ) == 0 ) compress = 0;
}
#endif

strncmpi( arg1, arg2, len )
char *arg1, *arg2;
int len;
{
    while ( toupper(*arg1)==toupper(*arg2) && len-- )
        {
        *arg1++;
        *arg2++;
        }
    return( toupper(*arg1) - toupper(*arg2) );
}

